﻿Imports System.Runtime.CompilerServices
Imports System.Net
Module Extensions
    Friend Enc As New System.Text.ASCIIEncoding
    <Extension()> Friend Function IsNull(ByVal b() As Byte) As Boolean
        For i = 0 To b.Length - 1
            If b(i) > 0 Then Return False
        Next
        Return True
    End Function
#Region "String Extensions"
    <Extension()> Private Function MakeCookies(ByVal pHeader As String) As String
        Dim result As String = ""
        Dim ck As String
        Do Until pHeader.ContainsI("Set-Cookie: ") = False
            ck = pHeader.GetValue("Set-Cookie: ")
            pHeader = pHeader.Replace("Set-Cookie: " & ck, "")
            result = result & ck & "; "
        Loop
        Return result
    End Function
    <Extension()> Friend Sub UpdateCookies(ByRef storedCookies As String, ByVal updateHeader As String)
        Dim newCookies As String = ""
        If storedCookies = "" Then storedCookies = updateHeader.MakeCookies
        Dim ck As String
        Do Until updateHeader.ContainsI("Set-Cookie: ") = False
            ck = updateHeader.GetValue("Set-Cookie: ")
            updateHeader = updateHeader.Replace("Set-Cookie: " & ck, "")
            newCookies = newCookies & ck & "; "
        Loop
        If newCookies = "" Then Exit Sub
        Dim cookieTag As String = newCookies.Substring(0, newCookies.IndexOf("="))
        Do Until newCookies.ContainsI("; ") = False
            ck = newCookies.GetCookieValue(cookieTag)
            If storedCookies.ContainsI(cookieTag) = False Then
                storedCookies = storedCookies & cookieTag & "=" & ck & "; "
            Else
                storedCookies.SetCookieValue(cookieTag, ck)
            End If
            newCookies = newCookies.Replace(cookieTag & "=" & ck & "; ", "")
            If newCookies.ContainsI("=") = False Then
                Exit Do
            Else
                cookieTag = newCookies.Substring(0, newCookies.IndexOf("="))
            End If
        Loop
    End Sub
    <Extension()> Friend Function URLBase(ByVal str As String) As String
        If str.Contains("http://") = False Then str = "http://" & str
        Return str.StringHereToHere("http://", "/")
    End Function
    <Extension()> Friend Function URLRest(ByVal str As String) As String
        str = str.Replace("http://", "")
        Return str.Replace(str.URLBase, "")
    End Function
    <Extension()> Friend Function ContainsI(ByVal str As String, ByVal value As String) As Boolean
        Return str.ToLower.Contains(value.ToLower)
    End Function
    <Extension()> _
  Function StringHereToHere(ByVal here As String, ByVal here1 As String, ByVal here2 As String) As String
        If here.CanStringHereToHere(here1, here2) = False Then Throw New Exception("String Param Mismatch")
        StringHereToHere = here.Substring(here.IndexOf(here1) + here1.Length, here.IndexOf(here2, here.IndexOf(here1) + here1.Length) - here.IndexOf(here1) - here1.Length)
    End Function
    <Extension()> Function CanStringHereToHere(ByVal here As String, ByVal here1 As String, ByVal here2 As String) As Boolean
        If here.Contains(here1) = False Or here.Contains(here2) = False Then
            Return False
        End If
        If here.Substring(here.IndexOf(here1) + here1.Length).Contains(here2) = False Then Return False
        Return True
    End Function
    <Extension()> _
Function GetValue(ByVal str As String, ByVal tag As String) As String
        If str.Contains(tag) Then
            Return str.StringHereToHere(tag, vbCrLf)
        ElseIf str.ContainsI(tag) Then
            Return str.ToLower.StringHereToHere(tag.ToLower, vbCrLf)
        Else
            Return Nothing
        End If
    End Function
    <Extension()> Friend Function FirstLine(ByVal str As String) As String
        Return str.Substring(0, str.IndexOf(vbCrLf))
    End Function
    <Extension()> Public Function PathEt(ByVal str As String) As String
        Return Replace(str & "\", "\\", "\")
    End Function
    <Extension()> _
Function GetCookieValue(ByVal str As String, ByVal tag As String) As String
        If str.Contains(tag) Then
            Return str.StringHereToHere(tag & "=", ";")
        Else
            Return str.ToLower.StringHereToHere(tag.ToLower & "=", ";")
        End If
    End Function
    <Extension()> _
Friend Sub SetCookieValue(ByRef str As String, ByVal tag As String, ByVal newValue As String)
        str = str.Replace(tag & "=" & str.GetCookieValue(tag), tag & "=" & newValue)
    End Sub
    <Extension()> _
Friend Sub AddLine(ByRef aString As String, ByVal bString As String)
        aString = aString & vbCrLf & bString
    End Sub
#End Region
#Region "User Agents"
    Friend Const M1 As String = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322)"
    Friend Const M2 As String = "Mozilla/4.0 (compatible; MSIE 5.00; Windows 98)"
    Friend Const NS As String = "NSPlayer/9.0.0.2980"
    Friend Const RMA As String = "RMA/1.0 (compatible; RealMedia)"
    Friend Const WMA As String = "WinampMPEG/5.0"
    Friend Const FF As String = "Mozilla/5.0 (Windows; U; Windows NT 6.0; en-US; rv:1.8.1.14) Gecko/20080404 Firefox/2.0.0.14"
    Enum User_Agents
        Internet_Explorer_6 = 0
        Internet_Explorer_5 = 1
        NSPlayer = 2
        RealOnePlayer = 3
        WinAmp = 4
        FireFox = 5
    End Enum
    <Extension()> Friend Function UAValue(ByVal str As User_Agents) As String
        If str = User_Agents.Internet_Explorer_6 Then Return M1
        If str = User_Agents.Internet_Explorer_5 Then Return M2
        If str = User_Agents.NSPlayer Then Return NS
        If str = User_Agents.RealOnePlayer Then Return RMA
        If str = User_Agents.WinAmp Then Return WMA
        If str = User_Agents.FireFox Then Return FF
        Return Nothing
    End Function
#End Region
#Region "Net Extensions"
    <Extension()> Private Sub ConnectTimeout(ByRef sc As Net.Sockets.Socket, ByVal timeout As int64)
        Dim t As New Threading.Thread(AddressOf ProxyTimedOut)
        Dim s(1) As Object
        s(0) = sc
        s(1) = timeout
        t.Start(s)
    End Sub
    <Extension()> Friend Function TryConnect(ByRef mSocket As Net.Sockets.Socket, ByVal Url As System.Uri, ByRef myLog As InfoLog) As Boolean
        Dim iRetry As int64
        Dim mEndpoint As Net.IPEndPoint
        For iRetry = 1 To myLog.dParentJob.iConnectRetries
            mSocket = New Sockets.Socket(Sockets.AddressFamily.InterNetwork, Sockets.SocketType.Stream, Sockets.ProtocolType.Tcp)
            Try
                myLog.Update(InfoLogItem.Direction.To_Server, "Resolving DNS of " & Url.Host & ":" & Url.Port)
                mEndpoint = New Net.IPEndPoint(Net.Dns.GetHostEntry(Url.Host).AddressList(0), Url.Port)
                myLog.Update(InfoLogItem.Direction.To_Client, "DNS Resolved: " & mEndpoint.ToString)
                myLog.Update(InfoLogItem.Direction.To_Server, "Connecting to " & mEndpoint.ToString)
                mSocket.ConnectTimeout(myLog.dParentJob.iConnectTimeout)
                mSocket.ReceiveTimeout = myLog.dParentJob.iRecieveTimeout
                mSocket.Connect(mEndpoint)
                myLog.Update(InfoLogItem.Direction.To_Client, "Connected to " & mEndpoint.ToString)
                Return True
            Catch ex As Exception
                myLog.Update(InfoLogItem.Direction._Error, ex.Message)
                myLog.dParentJob.HandleException(ex)
            End Try
        Next
        myLog.Update(InfoLogItem.Direction._Error, "Connect retries failed!")
        Return False
    End Function
    Private Sub ProxyTimedOut(ByVal s() As Object)
        Dim sc As Net.Sockets.Socket = s(0)
        Dim i As Int64 = s(1)
        Threading.Thread.Sleep(i)
        If sc.Connected = False Then
            sc.Close()
        End If
    End Sub
    <Extension()> Friend Function TrySend(ByRef mSocket As Net.Sockets.Socket, ByVal sBytes() As Byte, ByRef myLog As InfoLog) As Boolean
        Dim iRetry As Int64
        For iRetry = 1 To myLog.dParentJob.iSendRetries
            If mSocket.Connected = False Then Return False
            mSocket.SendTimeout = myLog.dParentJob.iRecieveTimeout
            Try
                myLog.Update(InfoLogItem.Direction.To_Server, "Sending header request:")
                myLog.Update(InfoLogItem.Direction.To_Server, Enc.GetString(sBytes))
                mSocket.Send(sBytes)
                myLog.Update(InfoLogItem.Direction.To_Client, "Header request sent.")
                Return True
            Catch ex As Exception
                myLog.Update(InfoLogItem.Direction._Error, ex.Message)
                myLog.dParentJob.HandleException(ex)
            End Try
        Next
        myLog.Update(InfoLogItem.Direction._Error, "Send retries failed!")
        Return False
    End Function
    <Extension()> Friend Function TryHeader(ByRef mSocket As Net.Sockets.Socket, ByRef rHeader As String, ByRef myLog As InfoLog) As Boolean
        Dim iRetry As Int64
        For iRetry = 1 To myLog.dParentJob.iRecieveRetries
            If mSocket.Connected = False Then myLog.Update(InfoLogItem.Direction._Error, "Server disconnected.") : Exit For
            mSocket.ReceiveTimeout = myLog.dParentJob.iRecieveTimeout
            Try
                myLog.Update(InfoLogItem.Direction.To_Server, "Recieving header.")
                rHeader = mSocket.GetHeader
                myLog.Update(InfoLogItem.Direction.To_Client, "Header recieved:")
                myLog.Update(InfoLogItem.Direction.To_Client, rHeader)
                Return True
            Catch ex As Exception
                myLog.Update(InfoLogItem.Direction._Error, ex.Message)
                myLog.dParentJob.HandleException(ex)
            End Try
        Next
        myLog.Update(InfoLogItem.Direction._Error, "Recieve header failed!")
        Return False
    End Function
    <Extension()> Private Function GetHeader(ByRef sc As Net.Sockets.Socket) As String
        Dim header As String = ""
        Dim rbuffer(0) As Byte
        Dim n As Int64
        Do
            n = sc.Receive(rbuffer, 1, Net.Sockets.SocketFlags.None)
            If n = 0 Then
                Dim i As Int64 = 0
                Do
                    n = sc.Receive(rbuffer, 0, 1, Net.Sockets.SocketFlags.None)
                    If n = 0 Then i = i + 1
                    If i = 100000 Then Throw New Exception("Header Data Error 0") : Return Nothing
                Loop Until n > 0
            End If
            header = header & Enc.GetString(rbuffer, 0, 1)
            If header.Contains(vbCrLf & vbCrLf) Then Exit Do
        Loop
        Return header
    End Function
    <Extension()> Private Sub GetData(ByRef sc As Net.Sockets.Socket, ByVal length As Int64, ByVal pos As Int64, ByRef myJob As ThreadRangeJob)
        Dim fsThread As New IO.FileStream(myJob.dParentJob.sFileLocation, IO.FileMode.OpenOrCreate, IO.FileAccess.ReadWrite, IO.FileShare.ReadWrite)
        fsThread.Position = pos
        Dim dataBuffer(myJob.dParentJob.iBufferSize - 1) As Byte
        Dim n As Int64
        Dim cur As Int64
        Do
            If length - cur < myJob.dParentJob.iBufferSize Then
                n = sc.Receive(dataBuffer, 0, length - cur, Sockets.SocketFlags.None)
            Else
                n = sc.Receive(dataBuffer, 0, myJob.dParentJob.iBufferSize, Sockets.SocketFlags.None)
            End If
            If n = 0 Then
                If cur = length Then Exit Do
                Dim i As Int64 = 0
                Do
                    n = sc.Receive(dataBuffer, 0, 1, Net.Sockets.SocketFlags.None)
                    If n = 0 Then i = i + 1
                    If i = 100000 Then fsThread.Close() : Throw New Exception("Downloading Data Error 0")
                Loop Until n > 0
            End If
            fsThread.Write(dataBuffer, 0, n)
            cur = cur + n
            myJob.UpdateCurrent(n)
            myJob.dParentJob.cStatBoard.AddDownloaded(n)
        Loop Until cur = length
        fsThread.Close()
    End Sub
    <Extension()> Private Sub GetAllData(ByRef sc As Net.Sockets.Socket, ByVal dParentJob As DownloadJob)
        Dim fsThread As New IO.FileStream(dParentJob.sFileLocation, IO.FileMode.OpenOrCreate, IO.FileAccess.ReadWrite, IO.FileShare.ReadWrite)
        fsThread.Position = 0
        Dim dataBuffer(dParentJob.iBufferSize - 1) As Byte
        Dim n As Int64
        Do
            n = sc.Receive(dataBuffer, 0, dParentJob.iBufferSize, Sockets.SocketFlags.None)
            If n = 0 Then
                Dim i As Int64 = 0
                Do
                    n = sc.Receive(dataBuffer, 0, 1, Net.Sockets.SocketFlags.None)
                    If n = 0 Then i = i + 1
                    If i = 100000 Then fsThread.Close() : Throw New Exception("Downloading Data Error 0")
                Loop Until n > 0
            End If
            fsThread.Write(dataBuffer, 0, n)
            dParentJob.cStatBoard.AddDownloaded(n)
        Loop
        fsThread.Close()
    End Sub
    <Extension()> Friend Sub TryGetData(ByRef mSocket As Net.Sockets.Socket, ByVal length As Int64, ByVal pos As Int64, ByRef WorkIsDone As Boolean, ByRef myJob As ThreadRangeJob, ByRef myLog As InfoLog)
        If mSocket.Connected = False Then WorkIsDone = False : Exit Sub
        mSocket.ReceiveTimeout = myJob.dParentJob.iRecieveTimeout
        myLog.Update(InfoLogItem.Direction.To_Client, "Recieving Data.")
        Try
            If myJob.dParentJob.iLength = 0 Or myJob.dParentJob.iLength = -1 Then
                If myJob.iStart = 0 And myJob.iCurrent = 0 Then
                    mSocket.GetAllData(myJob.dParentJob)
                    Exit Try
                Else
                    WorkIsDone = True
                    If myJob.iStart > 0 Then myLog.Update(InfoLogItem.Direction._Error, "Unresumable secondary thread must abort!")
                    If myJob.iStart = 0 Then myLog.Update(InfoLogItem.Direction._Error, "Download Finished. If its not, restart it.")
                    Exit Sub
                End If
            End If
            mSocket.GetData(length, pos, myJob)
        Catch ex As Exception
            myLog.Update(InfoLogItem.Direction._Error, ex.Message)
            myJob.dParentJob.HandleException(ex)
            WorkIsDone = False
            Exit Sub
        End Try
        WorkIsDone = True
    End Sub

    <Extension()> Private Sub GetRemainingData(ByRef sc As Net.Sockets.Socket, ByVal length As Int64, ByVal pos As Int64, ByVal dParentJob As DownloadJob)
        Dim fsThread As New IO.FileStream(dParentJob.sFileLocation, IO.FileMode.OpenOrCreate, IO.FileAccess.ReadWrite, IO.FileShare.ReadWrite)
        fsThread.Position = pos
        Dim dataBuffer(dParentJob.iBufferSize - 1) As Byte
        Dim n As Int64
        Dim cur As Int64
        Do
            If length - cur < dParentJob.iBufferSize Then
                n = sc.Receive(dataBuffer, 0, length - cur, Sockets.SocketFlags.None)
            Else
                n = sc.Receive(dataBuffer, 0, dParentJob.iBufferSize, Sockets.SocketFlags.None)
            End If
            If n = 0 Then
                If cur = length Then Exit Do
                Dim i As Int64 = 0
                Do
                    n = sc.Receive(dataBuffer, 0, 1, Net.Sockets.SocketFlags.None)
                    If n = 0 Then i = i + 1
                    If i = 100000 Then fsThread.Close() : Throw New Exception("Downloading Data Error 0")
                Loop Until n > 0
            End If
            fsThread.Write(dataBuffer, 0, n)
            cur = cur + n
            dParentJob.cStatBoard.AddDownloaded(n)
        Loop Until cur = length
        fsThread.Close()
    End Sub
    <Extension()> Friend Sub TryGetRemainingData(ByRef mSocket As Net.Sockets.Socket, ByVal pos As Int64, ByRef WorkIsDone As Boolean, ByRef myLog As InfoLog)
        If mSocket.Connected = False Then WorkIsDone = False : Exit Sub
        mSocket.ReceiveTimeout = myLog.dParentJob.iRecieveTimeout
        myLog.Update(InfoLogItem.Direction.To_Client, "Recieving Data.")
        Try
            mSocket.GetRemainingData(myLog.dParentJob.iLength - pos, pos, myLog.dParentJob)
        Catch ex As Exception
            myLog.Update(InfoLogItem.Direction._Error, ex.Message)
            myLog.dParentJob.HandleException(ex)
            WorkIsDone = False
            Exit Sub
        End Try
        WorkIsDone = True
    End Sub
#End Region
End Module
