﻿Public Class DownloadForm

    Private Sub DownloadForm_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If dManager.Items.Count = 0 Then Exit Sub
        For Each pw As ListViewItem In dManager.Items
            Dim djob As Download_Client.DownloadJob = pw.Tag
            djob.Pause()
        Next
    End Sub

    Private Sub DownloadForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Array.Resize(dSelectedJobs, 0)
        LoadImages()
        FixColumns()
        frmMain = Me
        LoadJobs()
        Dim dJob As New Download_Client.DownloadJob
        dJob.SetDownloadDetails("http://nba.cdn.turner.com/nba/big/channels/top_plays/2009/09/16/nba_20090916_lal_top10.nba_nba_576x324.flv", "C:\NBA\nba_20090916_lal_top10.nba_nba_576x324.flv", AddressOf HandleException, ClientJobSavePath, , , , , , iConnectTimeout, iRecieveTimeout, iSendTimeout, iConnectRetries, iSendRetries, iRecieveRetries, iBufferSize, 10, , iThreadRetryTime)
        AddJob(dJob)
        Threads.Items(0).Selected = True
    End Sub



#Region "Job Manager Subs"
    Private Sub LoadJobs()
        Dim xFile As IO.FileInfo
        Dim xDir As New IO.DirectoryInfo(ClientJobSavePath)
        For Each xFile In xDir.GetFiles
            If xFile.Extension = ".xml" Then
                Dim dJob As Download_Client.DownloadJob = Download_Client.Load(xFile.FullName)
                dJob.SetHandler(AddressOf HandleException, ClientJobSavePath)
                AddJob(dJob)
            End If
        Next
    End Sub
    Public Sub AddJob(ByRef dJob As Download_Client.DownloadJob)
        If dJob Is Nothing Then Exit Sub
        For Each lV As ListViewItem In dManager.Items
            Dim iJob As Download_Client.DownloadJob = lV.Tag
            If iJob.sDownloadURL = dJob.sDownloadURL And iJob.sReferer = dJob.sReferer And iJob.sCookies = dJob.sCookies Then MessageBox.Show("The same download job already exists!", "Duplicate Download", MessageBoxButtons.OK, MessageBoxIcon.Exclamation) : dJob.Delete() : Exit Sub
        Next
        Dim lvItem As New ListViewItem
        lvItem.Text = ""
        lvItem.SubItems.Add(dJob.sFileLocation.FileName)
        lvItem.SubItems.Add(dJob.iLength.ToSizeString)
        lvItem.SubItems.Add(dJob.cStatBoard.iDownloaded.ToSizeString)
        lvItem.SubItems.Add(Decimal.Round(dJob.cStatBoard.dPercent, 2) & "%")
        lvItem.SubItems.Add(dJob.cStatBoard.sDuration)
        lvItem.SubItems.Add(dJob.cStatBoard.iSpeed.ToSizeString & "\s")
        lvItem.SubItems.Add(dJob.cStatBoard.dSpeedAvg.ToSizeString & "\s")
        lvItem.SubItems.Add(dJob.cStatBoard.sETA)
        lvItem.Tag = dJob
        lvItem.ImageIndex = dJob.DownloadJobStatus
        AddHandler dJob.JobStatusChanged, AddressOf InvokeDownloadStatusChanged
        dManager.Items.Add(lvItem)
        For Each n As ListViewItem In dManager.SelectedItems
            n.Selected = False
        Next
        lvItem.Selected = True
        ReloadThreadLog(0)
    End Sub
#End Region

#Region "Form Appearances"
    Private Sub FixColumns()
        vLog.Columns(0).FixWidth()
        vLog.Columns(1).FixWidth()
        dManager.Columns(0).FixWidth(dManager.Columns(0).Width)
        dManager.Columns(1).FixWidth(dManager.Columns(1).Width)
        dManager.Columns(2).FixWidth(dManager.Columns(2).Width)
        dManager.Columns(3).FixWidth(dManager.Columns(3).Width)
        dManager.Columns(4).FixWidth(dManager.Columns(4).Width)
        dManager.Columns(5).FixWidth(dManager.Columns(5).Width)
        dManager.Columns(6).FixWidth(dManager.Columns(6).Width)
        dManager.Columns(7).FixWidth(dManager.Columns(7).Width)
        dManager.Columns(8).FixWidth(dManager.Columns(8).Width)
        Threads.Columns(0).FixWidth()
    End Sub
    Private Sub LoadImages()
        ManagerImages.Images.Add(My.Resources.status_queued)
        ManagerImages.Images.Add(My.Resources.status_started)
        ManagerImages.Images.Add(My.Resources.status_downloading)
        ManagerImages.Images.Add(My.Resources.status_done)
        ManagerImages.Images.Add(My.Resources.status_stopped)
        ManagerImages.Images.Add(My.Resources.status_paused)
        ManagerImages.Images.Add(My.Resources.log)
        ManagerImages.Images.Add(My.Resources._error)
    End Sub
    Private Sub Manager_DrawColumnHeader(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawListViewColumnHeaderEventArgs) Handles dManager.DrawColumnHeader
        e.DrawDefault = True
    End Sub
    Private Sub Manager_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawListViewItemEventArgs) Handles dManager.DrawItem
        If e.ItemIndex Mod 2 = 0 Then
            e.Item.BackColor = Color.OldLace
        Else
            e.Item.BackColor = Color.LightGoldenrodYellow
        End If
        e.DrawDefault = True
    End Sub
    Private Sub Manager_DrawSubItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawListViewSubItemEventArgs) Handles dManager.DrawSubItem
        e.DrawDefault = True
    End Sub
    Private Sub DrawThreads()
        Threads.Items.Clear()
        For i = 1 To dSelectJob.nThreads
            Dim lvItem As ListViewItem = Threads.Items.Add("Thread " & i)
            lvItem.ImageIndex = dSelectJob.cItemLog(i - 1).ThreadStatus
            AddHandler dSelectJob.cItemLog(i - 1).ThreadStatusChanged, AddressOf InvokeThreadStatusChanged
        Next
        For Each lvItem In Threads.Items
            lvItem.BackColor = Color.PapayaWhip
        Next
        For Each lvItem In Threads.SelectedItems
            lvItem.BackColor = Color.LightCoral
        Next
    End Sub
    Delegate Sub ThreadStatusChangedInvoker(ByVal tStatus As Download_Client.InfoLog.ThreadState, ByRef iLog As Download_Client.InfoLog)
    Private Sub InvokeThreadStatusChanged(ByVal tStatus As Download_Client.InfoLog.ThreadState, ByRef iLog As Download_Client.InfoLog)
        Dim nInvoker As New ThreadStatusChangedInvoker(AddressOf ThreadStatusChanged)
        If frmMain.Disposing = True Or frmMain.IsDisposed = True Then Exit Sub
        frmMain.Invoke(nInvoker, New Object() {tStatus, iLog})
    End Sub
    Private Sub ThreadStatusChanged(ByVal tStatus As Download_Client.InfoLog.ThreadState, ByRef iLog As Download_Client.InfoLog)
        Dim index As Integer = Array.IndexOf(dSelectJob.cItemLog, iLog)
        Threads.Items(index).ImageIndex = tStatus
    End Sub
    Delegate Sub DownloadStatusChangedInvoker(ByVal dStatus As Download_Client.DownloadJob.Status, ByRef dJob As Download_Client.DownloadJob)
    Private Sub InvokeDownloadStatusChanged(ByVal dStatus As Download_Client.DownloadJob.Status, ByRef dJob As Download_Client.DownloadJob)
        Dim nInvoker As New DownloadStatusChangedInvoker(AddressOf DownloadStatusChanged)
        If frmMain.Disposing = True Or frmMain.IsDisposed = True Then Exit Sub
        frmMain.Invoke(nInvoker, New Object() {dStatus, dJob})
    End Sub
    Private Sub DownloadStatusChanged(ByVal dStatus As Download_Client.DownloadJob.Status, ByRef dJob As Download_Client.DownloadJob)
        Dim lvItem As ListViewItem
        For Each lvItem In dManager.Items
            If lvItem.Tag Is dJob Then lvItem.ImageIndex = dStatus
        Next
    End Sub
#End Region



#Region "Reporting Subs"
    Private Sub Threads_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Threads.SelectedIndexChanged
        Dim lvItem As ListViewItem
        For Each lvItem In Threads.Items
            lvItem.BackColor = Color.PapayaWhip
        Next
        For Each lvItem In Threads.SelectedItems
            lvItem.BackColor = Color.LightCoral
        Next
        If Threads.SelectedItems.Count > 0 Then
            ReloadThreadLog(Threads.SelectedItems(0).Index)
        End If
    End Sub
    Delegate Sub InvokeItem(ByVal infoItem As Download_Client.InfoLogItem)
    Private Sub InvokeNewItemThreadLog(ByVal infoItem As Download_Client.InfoLogItem)
        Dim dInvoker As New InvokeItem(AddressOf NewItemThreadLog)
        If frmMain.Disposing = True Or frmMain.IsDisposed = True Or frmMain Is Nothing Then Exit Sub
        frmMain.Invoke(dInvoker, infoItem)
        dInvoker = New InvokeItem(AddressOf InvokeNewItemThreadLog)
    End Sub
    Private Sub NewItemThreadLog(ByVal infoItem As Download_Client.InfoLogItem)
        Dim sText As String = infoItem.ItemText
        If sText = Nothing Then Exit Sub
        sText = sText & vbCrLf
        Dim itemText As String
        Do Until sText = Nothing
            itemText = sText.Substring(0, sText.IndexOf(vbCrLf))
            sText = sText.Substring(sText.IndexOf(vbCrLf) + 2)
            If itemText = vbCrLf Or itemText = "" Then Continue Do
            Dim lItem As ListViewItem = frmMain.vLog.Items.Add(infoItem.ItemTime)
            lItem.SubItems.Add(itemText)
            lItem.BackColor = infoItem.ItemColor
            lItem.EnsureVisible()
        Loop
    End Sub
    Private Sub Manager_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dManager.SelectedIndexChanged
        If dManager.SelectedItems.Count > 0 Then
            Array.Resize(dSelectedJobs, dManager.SelectedItems.Count)
            pSelectJob = dSelectJob
            For i = 0 To dManager.SelectedItems.Count - 1
                Dim dJob As Download_Client.DownloadJob = dManager.SelectedItems(i).Tag
                dSelectedJobs(i) = dJob
            Next
            If dSelectJob Is dSelectedJobs(0) Then Exit Sub
            dSelectJob = dSelectedJobs(0)
            If pSelectJob Is dSelectJob Then Exit Sub
            If Not pSelectJob Is Nothing Then
                For i = 0 To pSelectJob.cItemLog.Length - 1
                    RemoveHandler pSelectJob.cItemLog(i).ThreadStatusChanged, AddressOf InvokeThreadStatusChanged
                Next
            End If
            DrawThreads()
            Threads.Items(0).Selected = True
            ReloadThreadLog(0)
        End If
    End Sub
    Private Sub ReloadThreadLog(ByVal nThreadIndex As int64)
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim cItemLog As Download_Client.InfoLog = dSelectJob.cItemLog(nThreadIndex)
        If cHandledThread Is cItemLog Then Exit Sub
        If Not cHandledThread Is Nothing Then
            RemoveHandler cHandledThread.NewItem, AddressOf InvokeNewItemThreadLog
        End If
        vLog.Items.Clear()
        For Each cItem In cItemLog.InfoItemList
            InvokeNewItemThreadLog(cItem)
        Next
        cHandledThread = cItemLog
        AddHandler cItemLog.NewItem, AddressOf InvokeNewItemThreadLog
    End Sub

#End Region

#Region "Button Functions"
    Private Sub btnPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPause.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        For Each SelectedJob In dSelectedJobs
            SelectedJob.Pause()
        Next
    End Sub
    Private Sub btnResume_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnResume.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        For Each SelectedJob In dSelectedJobs
            SelectedJob.Start()
        Next
    End Sub
    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        On Error Resume Next
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        For Each SelectedJob In dSelectedJobs
            For i = 0 To dManager.Items.Count - 1
                If dManager.Items(i).Tag Is SelectedJob Then
                    dManager.Items(i).Remove()
                    'dManager.Items(i).Selected = True
                    SelectedJob = Nothing
                    '                    SelectedJob.ID = Nothing
                    vLog.Items.Clear()
                End If
            Next
        Next

    End Sub
    Private Sub btnFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFile.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        For Each SelectedJob In dSelectedJobs
            If IO.File.Exists(SelectedJob.sFileLocation) = True Then Process.Start(SelectedJob.sFileLocation)
        Next
    End Sub
    Private Sub btnFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFolder.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        For Each SelectedJob In dSelectedJobs
            '   If IO.File.Exists(SelectedJob.sFileLocation) = True Then OpenSelect(SelectedJob.sFileLocation)
        Next
    End Sub
    Private Sub btnCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCopy.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        Dim cpText As String = ""
        For Each SelectedJob In dSelectedJobs
            cpText = cpText & SelectedJob.sDownloadURL & vbCrLf
        Next
        Clipboard.SetText(cpText)
    End Sub
    Private Sub btnNetTransport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNetTransport.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        For Each SelectedJob In dSelectedJobs
            '    NTADDLink(SelectedJob.sDownloadURL, SelectedJob.sReferer, "From NBA VC4")
        Next
    End Sub
    Private Sub btnFlashGet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFlashGet.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        For Each SelectedJob In dSelectedJobs
            ' FGADDLink(SelectedJob.sDownloadURL, SelectedJob.sReferer, "From NBA VC4")
        Next
    End Sub
    Private Sub btnConvertTVC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConvertTVC.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        For Each SelectedJob In dSelectedJobs
            If IO.File.Exists(SelectedJob.sFileLocation) = False Then Continue For
        Next
        ' If ProcessCheck("Total Video Converter", "Total Video Converter\tvc.exe", "tvc.exe", TVCProcessPath, "TVCProcessPath") = False Then Exit Sub
    End Sub
    Private Sub btnConvertBoilsoft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConvertBoilsoft.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        ' If ProcessCheck("Boilsoft ASF Converter", "Boilsoft ASF Converter\ASFConverter.exe", "ASFConverter.exe", ASFProcessPath, "ASFProcessPath") = False Then Exit Sub
        For Each SelectedJob In dSelectedJobs
            '  If BringProcessToFront("ASFConverter", ASFProcessPath) = False Then Exit Sub
            If IO.File.Exists(SelectedJob.sFileLocation) = False Then Continue For
            SendKeys.Send("a")
            'Sleep(1000)
            SendKeys.SendWait(SelectedJob.sFileLocation)
            'Sleep(500)
            SendKeys.Send("{Enter}")
        Next
        'PressProcessButton("ASFConverter", "Add")
    End Sub
    Private Sub btnConvertFLV_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConvertFLV.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        ' If ProcessCheck("FLV Converter", "FLV to AVI MPEG WMV 3GP MP4 iPod Converter\FLV to AVI MPEG WMV 3GP MP4 iPod Converter.exe", "FLV to AVI MPEG WMV 3GP MP4 iPod Converter.exe", FLVProcessPath, "FLVProcessPath") = False Then Exit Sub
        For Each SelectedJob In dSelectedJobs
            If IO.File.Exists(SelectedJob.sFileLocation) = False Then Continue For
            'If BringProcessToFront("FLV to AVI MPEG WMV 3GP MP4 iPod Converter", FLVProcessPath) = False Then Exit Sub
            SendKeys.SendWait("%(a)")
            '        Exit Sub
            'Sleep(1000)
            SendKeys.SendWait(SelectedJob.sFileLocation)
            'Sleep(500)
            SendKeys.Send("{Enter}")
        Next
    End Sub
    Private Sub btnImportWMM_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnImportWMM.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        ' If ProcessCheck("Windows Movie Maker", "Movie Maker\MOVIEMK.exe", "MOVIEMK.exe", MMProcessPath, "MMProcessPath") = False Then Exit Sub
        For Each SelectedJob In dSelectedJobs
            If IO.File.Exists(SelectedJob.sFileLocation) = False Then Continue For
            '  If BringProcessToFront("MOVIEMK", MMProcessPath) = False Then Exit Sub
            '        PressProcessButton("MOVIEMK", "Import Media")
            SendKeys.SendWait("^(i)")
            '        Exit Sub
            'Sleep(1000)
            ' SendKeys.SendWait(SelectedJob.sFileLocation.FolderPath)
            'Sleep(200)
            SendKeys.Send("{Enter}")
            'Sleep(500)
            '   SendKeys.SendWait(SelectedJob.sFileLocation.FileName)
        Next
    End Sub
    Private Sub btnImportVegas_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnImportVegas.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        ' If ProcessCheck("Sony Vegas 8.0", "Sony\Vegas Pro 8.0\vegas80.exe", "vegas80.exe", VegasProcessPath, "VegasProcessPath") = False Then Exit Sub
        For Each SelectedJob In dSelectedJobs
            If IO.File.Exists(SelectedJob.sFileLocation) = False Then Continue For
            '   If BringProcessToFront("vegas80", VegasProcessPath) = False Then Exit Sub
            '        PressProcessButton("MOVIEMK", "Import Media")
            'Sleep(1000)
            SendKeys.SendWait("%(fim)")
            '        Exit Sub
            'Sleep(1000)
            ' SendKeys.SendWait(SelectedJob.sFileLocation.FolderPath)
            'Sleep(200)
            'SendKeys.Send("{Enter}")
            'Sleep(500)
            ' SendKeys.SendWait(SelectedJob.sFileLocation.FileName)
        Next
    End Sub
    Private Sub btnIE_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnIE.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        For Each SelectedJob In dSelectedJobs
            Process.Start(SelectedJob.sDownloadURL)
        Next
    End Sub
    Private Sub btnCopyF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCopyF.Click
        If dSelectedJobs.Length = 0 Then Exit Sub
        Dim SelectedJob As Download_Client.DownloadJob
        Dim fN As New Collections.Specialized.StringCollection()
        For Each SelectedJob In dSelectedJobs
            If IO.File.Exists(SelectedJob.sFileLocation) = False Then Continue For
            fN.Add(SelectedJob.sFileLocation)
        Next
        Clipboard.SetFileDropList(fN)
    End Sub
    Private Sub btnOpenWith_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Process.Start("MPlayerFileVideo")
    End Sub
#End Region


    Private Sub UpdateManager_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UpdateManager.Tick
        Dim djItem As ListViewItem
        Dim dJob As Download_Client.DownloadJob
        For Each djItem In dManager.Items
            dJob = djItem.Tag
            Dim lvItem As ListViewItem = Nothing
            Dim vItem As ListViewItem
            For Each vItem In dManager.Items
                If vItem.Tag Is dJob Then lvItem = vItem : Exit For
            Next
            If lvItem Is Nothing Then Exit Sub
            lvItem.SubItems(2).Text = dJob.iLength.ToSizeString
            lvItem.SubItems(3).Text = dJob.cStatBoard.iDownloaded.ToSizeString
            lvItem.SubItems(4).Text = Decimal.Round(dJob.cStatBoard.dPercent, 2) & "%"
            lvItem.SubItems(5).Text = dJob.cStatBoard.sDuration
            lvItem.SubItems(6).Text = dJob.cStatBoard.iSpeed.ToSizeString & "\s"
            lvItem.SubItems(7).Text = dJob.cStatBoard.dSpeedAvg.ToSizeString & "\s"
            lvItem.SubItems(8).Text = dJob.cStatBoard.sETA
            dJob.cStatBoard.iSpeed = 0
        Next
    End Sub


End Class
