﻿Imports System.Runtime.CompilerServices
Module ManagerExtensions
#Region "ListView Extensions"
    <Extension()> Public Sub FixWidth(ByVal c As ColumnHeader, Optional ByVal width As int64 = -1)
        If width = -1 Then width = c.Width
        RemoveHandler c.ListView.ColumnWidthChanged, AddressOf ListViewWidthChanged
        c.Tag = width
        If c.Width <> width Then c.Width = width
        AddHandler c.ListView.ColumnWidthChanged, AddressOf ListViewWidthChanged
    End Sub
    Private Sub ListViewWidthChanged(ByVal sender As Object, ByVal c As ColumnWidthChangedEventArgs)
        Dim LW As ListView = sender
        Dim CM As ColumnHeader = LW.Columns(c.ColumnIndex)
        Dim W As int64 = CM.Tag
        If CM.Width <> W Then CM.Width = W
    End Sub
    Class ListViewItemComparer
        Implements IComparer

        Private col As Integer

        Public Sub New()
            col = 0
        End Sub

        Public Sub New(ByVal column As int64)
            col = column
        End Sub

        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
           Implements IComparer.Compare
            Dim pw As ListViewItem = CType(x, ListViewItem)
            Dim i1 As Int64 = pw.SubItems(col).Text
            pw = CType(y, ListViewItem)
            Dim i2 As Int64 = pw.SubItems(col).Text
            Return i2.CompareTo(i1)
        End Function
    End Class
#End Region

#Region "String & Number Extensions"
    <Extension()> Public Function PathEt(ByVal str As String) As String
        Return Replace(str & "\", "\\", "\")
    End Function
    <Extension()> _
Public Sub AddLine(ByRef aString As String, ByVal bString As String)
        aString = aString & vbCrLf & bString
    End Sub
    <Extension()> Public Function FromXTillEnd(ByVal here As String, ByVal x As String) As String
        Return StringEndToEnd(here & "**ENDX**", x, "**ENDX**")
    End Function
    <Extension()> Public Function StringEndToEnd(ByVal here As String, ByVal here1 As String, ByVal here2 As String) As String
        StringEndToEnd = here.Substring(here.Substring(0, here.IndexOf(here2)).LastIndexOf(here1) + here1.Length, here.LastIndexOf(here2) - here.Substring(0, here.IndexOf(here2)).LastIndexOf(here1) - here1.Length)
    End Function
    <Extension()> Public Function FileName(ByVal str As String) As String
        Dim f As New IO.FileInfo(str)
        Return f.Name
    End Function
    <Extension()> Public Function ToSizeString(ByVal nBytes As Int64) As String
        If nBytes < 0 Then Return "0"
        If nBytes > 1024 And nBytes < 1024 * 1024 Then
            Return nBytes.DecimalDivide(1024) & "KB"
        ElseIf nBytes >= 1024 * 1024 Then
            Return nBytes.DecimalDivide(1024 * 1024) & "MB"
        Else
            Return nBytes & "B"
        End If
    End Function

    <Extension()> Public Function DecimalDivide(ByVal i As int64, ByVal d As int64) As String
        Dim s As String = New Decimal(i / d).ToString
        If s.IndexOf(".") + 3 > s.Length Then
            Return s
        Else
            Return s.Substring(0, s.IndexOf(".") + 3)
        End If
    End Function
#End Region

End Module

